Page MenuHomePhabricator

New service request - PDF Render
Closed, ResolvedPublic

Description

About

This is a request to put the PDF rendering service on SCB. The service runs in a virtual browser and converts HTML to PDF/ PNG / JPEG. Even though it can convert HTML to PNG and JPEG as well, the primary focus is going to be on the conversion to PDF. It based on Electron.

Request Flow

The service will only be used to convert Wiki pages for MW installations inside the WMF production environment. WM Germany is working to expose this via the "Download as PDF" link in the sidebar, either as a modification of Special:Book, or as a direct link to the API result. Either way, the PDF will be requested through an experimental REST API end point (most likely /{domain}/v1/page/pdf/{title}), which will be owned by the Services team. From there, a request will be sent to the internal PDF rendering service on SCB to render the given url (http://{domain}/wiki/{title}).

Service Info

OwnerServices
Contact person@GWicke / @mobrovac / @Pchelolo
TimelineASAP
Source codeelectron-render
Target clusterSCB

See Also

Details

Related Gerrit Patches:
operations/puppet : productionPDF Render: Create the service's admin group
operations/puppet : productionPDF Render: Add libasound and libgtk2
operations/puppet : productionPDF Render: Add missing libgconf2 library package
operations/puppet : productionPDF Render Service: Add to SCB
operations/puppet : productionPDF Render Service: Role and module
mediawiki/services/electron-render/deploy : masterAdd Scap3 deployment configuration

Related Objects

StatusAssignedTask
ResolvedJhernandez
Resolved atgo
DeclinedNone
ResolvedNone
DeclinedNone
OpenJKatzWMF
StalledNone
ResolvedWMDE-Fisch
ResolvedAddshore
InvalidNone
InvalidNone
ResolvedTobi_WMDE_SW
ResolvedTobi_WMDE_SW
Resolvedgabriel-wmde
ResolvedAddshore
ResolvedTobi_WMDE_SW
ResolvedTobi_WMDE_SW
ResolvedTobi_WMDE_SW
DeclinedNone
ResolvedTobi_WMDE_SW
Resolved GWicke
Resolvedmobrovac
Resolved Lea_WMDE
ResolvedAddshore

Event Timeline

mobrovac created this task.Aug 16 2016, 5:43 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 16 2016, 5:43 PM
GWicke updated the task description. (Show Details)Aug 16 2016, 7:11 PM

Change 305256 had a related patch set uploaded (by Mobrovac):
PDF Render Service: Role and module

https://gerrit.wikimedia.org/r/305256

Change 305259 had a related patch set uploaded (by Mobrovac):
PDF Render Service: Add to SCB

https://gerrit.wikimedia.org/r/305259

Change 305281 had a related patch set uploaded (by Mobrovac):
Add Scap3 deployment configuration

https://gerrit.wikimedia.org/r/305281

Change 305281 merged by Mobrovac:
Add Scap3 deployment configuration

https://gerrit.wikimedia.org/r/305281

Elitre added a subscriber: Elitre.Aug 18 2016, 5:33 PM
mobrovac triaged this task as Medium priority.Sep 19 2016, 2:27 PM

Change 305256 merged by Giuseppe Lavagetto:
PDF Render Service: Role and module

https://gerrit.wikimedia.org/r/305256

Change 305259 merged by Giuseppe Lavagetto:
PDF Render Service: Add to SCB

https://gerrit.wikimedia.org/r/305259

Change 322878 had a related patch set uploaded (by Mobrovac):
PDF Render: Add missing libgconf2 library package

https://gerrit.wikimedia.org/r/322878

Change 322878 merged by Giuseppe Lavagetto:
PDF Render: Add missing libgconf2 library package

https://gerrit.wikimedia.org/r/322878

Change 322881 had a related patch set uploaded (by Mobrovac):
PDF Render: Add libasound and libgtk2

https://gerrit.wikimedia.org/r/322881

Change 322881 merged by Giuseppe Lavagetto:
PDF Render: Add libasound and libgtk2

https://gerrit.wikimedia.org/r/322881

mobrovac changed the task status from Open to Stalled.Nov 22 2016, 3:27 PM
mobrovac edited projects, added User-Joe; removed Patch-For-Review.

The service has been deployed on SCB, but is not active yet because its functioning depends on installing firejail 0.9.44 on scb100x. Setting as stalled until that happens.

Joe moved this task from Backlog to Doing on the User-Joe board.Nov 23 2016, 9:55 AM

Change 323195 had a related patch set uploaded (by Mobrovac):
PDF Render: Create the service's admin group

https://gerrit.wikimedia.org/r/323195

Joe closed this task as Resolved.Nov 29 2016, 10:56 AM

Change 323195 merged by Alexandros Kosiaris:
PDF Render: Create the service's admin group

https://gerrit.wikimedia.org/r/323195

Dzahn added a subscriber: Dzahn.EditedJun 13 2017, 7:51 PM

Today there was an incident where ORES on scb1001 was unhappy (T167819) and looking at top one process ( 10971 (pdfrendering/electron)) was using like all of the CPU. Since i couldn't see other obvious reasons i killed that one process and that actually resolved the issue.

12:44 < mutante> Amir1: 19:24 mutante: scb1001 - killed process 10971 (pdfrendering/electron)
12:44 < mutante> 20 minutes ago
12:44 < Amir1> mutante: Yes, that's the reason
12:44 < Amir1> https://grafana.wikimedia.org/dashboard/db/ores?orgId=1&panelId=3&fullscreen
12:45 < Amir1> look when ores in scb1001 is going to take more requests